
import 'package:flutter/cupertino.dart';
import 'package:easyflu/config/const.dart';
import 'package:easyflu/http/exception/http_error.dart';
import 'package:easyflu/http/http_data.dart';

import 'base_view_state.dart';

mixin BaseRequestListController<T> on BaseViewState{

  /// 页面数据
  List<T> list = [];



  ///获取数据
  Future<HttpData<List<T>>> refreshData(){
    return requestList<List<T>, T>((httpData, requestInfo){
      list = httpData.data;
      onCompleted(list);
      setIdle();
      return httpData;
    });
  }


  onCompleted(List<T> data) {}

}